#!/bin/sh

# Copyright 2016, 2021 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

. "$_EXEC"/cgilite/storage.sh
. "$_EXEC"/pdiread.sh

catfile="${_DATA}/mappings/categories"

for card in "${_DATA}"/vcard/*.vcf; do
  n='' postcats='' cardcats=''
  vcf="$(pdi_load "$card")"

  n=1; while postcats="${postcats}${postcats:+,}$(POST "${card##*/}" $n)"; do n=$((n+1)); done
  n=1; while cardcats="${cardcats}${cardcats:+,}$(pdi_value "$vcf" CATEGORIES $n)"; do n=$((n+1)); done

  if [ "${postcats}" != "${cardcats}" ] && LOCK "$card"; then
    sed -E -i '
      /^CATEGORIES[;:]/d
      /^END;?:VCARD *\r?$/iCATEGORIES:'"${postcats%,}"'\r
    ' "${card}"
    RELEASE "$card"
  fi
done

REDIRECT /categories/
